/** Diese Klasse ist klein aber fein! Ein echtes Brachtstck!<br>
 * Ein Blickfeld ist die Verbindung des Agenten mit der Nest. Der Agent orientiert sich ja nicht nach absoluten Koordinaten,
 * sondern relativ zu ihm selbst. Ein Blickfeld dient dazu diese relativen Koordinaten in absolute umzurechnen. Deshalb ist bei allen Methodenaufrufen
 * die aktuelle Position des Agenten mitzubergeben.<br>
 * Es reicht pro Nest ein Blickfeld aus.
 *
 * Stand: 09.07.2001
 */


public class Blickfeld{
    protected Koord3D[] view;
    protected Nest umgebung;
   
    // anstelle von i,j habe ich(Steffen) hier x,y eingesetzt. 31.5.2001
    // das ganze richtiggemacht am 6.6. von Clemens
    /** Der Konstruktor erzeugt nur ein Translationsarray.
     *
     * @param pos Position des Agenten im Sicht-block. Z.b. bei 3x3x3 sitzt der Agent in der Mitte, also (1,1,1)
     * @param weite Die Sichtweite, z.b. (3,3,3)
     * @param hier Nest, fr die dieses Blickfeld eingesetzt wird
     */
    public Blickfeld(Koord3D pos, Koord3D weite, Nest hier)
    {
        view = new Koord3D[ weite.getX() * weite.getY() * weite.getZ()];
        umgebung = hier;

        int index = 0;
        for( int z = 0; z < weite.getZ(); z++){
            for (int y = 0; y < weite.getY(); y++){
                for (int x = 0; x < weite.getX(); x++){
                    view[index] = new Koord3D( x - pos.getX(), y - pos.getY(), z - pos.getZ() );
                    index++;
                }
            }
        }
    }


    /** Liefert die Blockart am angegebenen Punkt. Diese Methode wird z.B. dann verwendet, wenn der Agent umher blickt.
     *
     * @param pos Richtung, in die geschaut werden soll
     * @param posAgent die aktuelle Position des Agenten (absolut)
     */
    public char getStateAt( int pos, Koord3D posAgent ){
        return umgebung.getStateAtCoord( translate( pos, posAgent ));
    }

    /** Diese Methode wird zum bersetzen der relativen in die absoluten Koordinaten verwendet.
     *
     * @param pos Richtung, in die geschaut werden soll
     * @param posAgent die aktuelle Position des Agenten (absolut)
     */
    public Koord3D translate( int pos, Koord3D posAgent ){
        return new Koord3D( posAgent.getX()+view[ pos ].getX(), posAgent.getY()+view[ pos ].getY(), posAgent.getZ()+view[pos].getZ());
    }

    /** Liefert die Grsse zurck. Was auch immer.
     */
    public int size(){
        return view.length;
    }
}
