/**
 * Title: Hilfe
 * Description: Klasse um die Hilfe Datei einzuzeigen.
 * Diese Dateien sind im HTML-Format gespeichert.
 * Die einstellung fuer die zu lesende HTML-Datein kann man
 * in dem Array "urlString" duchfuehren.
 * @author Dimitri Missoh & Daniel Schlosser
 * @version 0.1
 */

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

import java.net.URL;
import java.io.IOException;

public class Hilfe extends JDialog//JFrame
{
	//hier ist der Konstruktor definiert.
	public Hilfe(Frame parent) {
		this.setTitle("Hilfe Nestbau-Simulation sozialer Insekten");
		this.setSize(350, 300);
                BorderLayout border = new BorderLayout();
                getContentPane().setLayout(border);
                Container cp = getContentPane();
		//array mit der Namen der HTML-Datein
		String [][] urlString = {{"helpFile_1.html", "helpFile_2.html", "helpFile_3.html"},
                                                                 {"Kurzanleitung", "Einfhrung", "Aktionen auf die 3D-Struktur"}
								};
		//Hier muss man den Name des Verzeichnis der Hilfe-Datei definieren.
		String folder = "folderHelp";

		JTabbedPane tp = new JTabbedPane();

		for (int i = 0; i < 3; ++i) {
			//erzeugt ein editor pane, das die Html-Datei enthaehlt
			JEditorPane editorPane = new JEditorPane();
			editorPane.setEditable(false);
			String s = null;
//Wichtig nderung bezglich des Verzeichnisses in Unterverzeichnis des Verzeichnis von TheHive
			try{
				s = "file:"
				+ System.getProperty("user.dir")
				+ System.getProperty("file.separator")
				+ folder
				+ System.getProperty("file.separator")
				+ urlString[0][i];
				URL helpURL = new URL(s);
				displayURL(helpURL, editorPane);
			} catch(Exception e) {
				System.err.println("Erzeugen von der " +
							   	   "Hilfedatei unmoeglich: " + s);
			}
			//erzeugt das scrollable Pane, das die HTML-Datein enthaelt
			JScrollPane paneScrollPane = new JScrollPane(editorPane);
			paneScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			paneScrollPane.setPreferredSize(new Dimension(250, 155));
        	paneScrollPane.setMinimumSize(new Dimension(10, 10));

			tp.addTab(urlString[1][i], paneScrollPane);
		}//Ende der for-Schleife

        cp.add(tp, BorderLayout.CENTER);
	}//Ende des Konstruktors Hilfe

	/**
	 *methode zur Einstellung fuer das URL des editorPane
	 *@param url editorPane erwartet ein URL und das editorPane.
	 *@return hat keinen Rueckgabewert.
	 */
	private void displayURL(URL url, JEditorPane editorPane)
	{
		try
		{
			editorPane.setPage(url);
		} catch(IOException e) {
			System.err.println("Versuch eine falshe URL zu lesen: " +
					   url);
		}
	}//Ende Methode displayURL

	public void setVisible(boolean b)
	{
		if(b)
                    super.setLocation(50,50);
                super.setVisible(b);
	}
}
