
/** Mit dieser Klasse werden alle Indexverschiebungen erzeugt, die im PatternGenerator gebraucht werden um ein Gen zu drehen.
 * Es handelt sich hierbei um eine Singleton-Klasse, d.h. es gibt keinen public-Konstruktor. Instanzen dieser Klasse erhlt man ber
 * die static-Methode getMirror().
 *
 * Stand: 09.07.2001
 */
public class MirrorGenerator{
    protected static MirrorGenerator mirror;
    protected int size;
    protected int[][] mirrorArray;
    public int length;  // makeMirror

    protected MirrorGenerator( int size ){
        this.size = size;
        
        mirrorArray = makeMirror( size );
    }
 
    /** ber diese Methode erhlt man eine Instanz dieser Singleton-Klasse.
     *
     * Gendert: ?
     *
     * @param size Grsse eines zu drehenden Patterns (Gengrsse)
     * @return na, die Instanz halt!
     */
    public static MirrorGenerator getMirror( int size ){
        if( mirror == null || mirror.size != size ){
            mirror = new MirrorGenerator( size );
        }

        return mirror;
    }

    /** Liefert eine Drehung.
     *
     * Gendert: ?
     *
     * @param index Index der Drehung
     * @return int[] mit vertauschten Indizes
     */
    public int[] get( int index ){
        return mirrorArray[ index ];
    }

    /**
     *
     * Gendert: 19.06.2001 mit Dank an <a href="mailto:bernd.jaekel@web.de">Bernd Jaekel</a>
     */
    protected int[][] makeMirror(int genSize) {
        length = 24;
        int[][] mirror_new = new int[length][genSize * genSize * genSize];
        int flat = genSize*genSize;

        int index = 0;
        for (int i = 0; i < genSize; i++) {
            for (int j = 0; j < genSize; j++) {
                for (int k = 0; k < genSize; k++) {
                    mirror_new[0][flat * i + genSize * j + k] = index;
                    mirror_new[1][flat * k + genSize * i + j] = index;
                    mirror_new[2][flat * j + genSize * k + i] = index;
                    mirror_new[3][flat * ((genSize - 1) -  i) + genSize * k + j] = index;
                    mirror_new[4][flat * k + genSize * j + ((genSize - 1) -  i)] = index;
                    mirror_new[5][flat * j + genSize * ((genSize - 1) -  i) + k] = index;
                    mirror_new[6][flat * i + genSize * k + ((genSize - 1) -  j)] = index;
                    mirror_new[7][flat * k + genSize * ((genSize - 1) -  j) + i] = index;
                    mirror_new[8][flat * ((genSize - 1) -  j) + genSize * i + k] = index;
                    mirror_new[9][flat * i + genSize * ((genSize - 1) -  k) + j] = index;
                    mirror_new[10][flat * ((genSize - 1) -  k) + genSize * j + i] = index;
                    mirror_new[11][flat * j + genSize * i + ((genSize - 1) -  k)] = index;
                    mirror_new[12][flat * ((genSize - 1) -  i) + genSize * ((genSize - 1) - j)  + k] = index;
                    mirror_new[13][flat * k + genSize * ((genSize - 1) -  i) + ((genSize - 1) -  j)] = index;
                    mirror_new[14][flat * ((genSize - 1) -  j) + genSize * k + ((genSize - 1) -  i)] = index;
                    mirror_new[15][flat * i + genSize * ((genSize - 1) -  j) + ((genSize - 1) -  k)] = index;
                    mirror_new[16][flat * ((genSize - 1) -  k) + genSize * i + ((genSize - 1) -  j)] = index;
                    mirror_new[17][flat * ((genSize - 1) -  j) + genSize * ((genSize - 1) - k) + i] = index;
                    mirror_new[18][flat * ((genSize - 1) -  i) + genSize * j + ((genSize - 1) - k)] = index;
                    mirror_new[19][flat * ((genSize - 1) -  k) + genSize * ((genSize - 1) -  i) + j] = index;
                    mirror_new[20][flat * j + genSize * ((genSize - 1) -  k) + ((genSize - 1) -  i)] = index;
                    mirror_new[21][flat * ((genSize - 1) -  i) + genSize * ((genSize - 1) -  k) + ((genSize - 1) -  j)] = index;
                    mirror_new[22][flat * ((genSize - 1) -  k) + genSize * ((genSize - 1) -  j) + ((genSize - 1) -  i)] = index;
                    mirror_new[23][flat * ((genSize - 1) -  j) + genSize * ((genSize - 1) -  i) + ((genSize - 1) -  k)] = index;

                    index++;
                }
            }
        }

        return mirror_new;
    }
}
